Index: src/Filling/Makefile.am
===================================================================
--- src/Filling/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Makefile.am	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,84 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+FILLINGSOURCE = \
+	Filling/Cluster.cpp \
+	Filling/Mesh/CubeMesh.cpp \
+	Filling/Mesh/Mesh.cpp \
+	Filling/Filler.cpp \
+	Filling/Generators/NodeGenerator.cpp \
+	Filling/Inserter/Inserter.cpp \
+	Filling/Inserter/RandomInserter.cpp \
+	Filling/Inserter/SimpleInserter.cpp \
+	Filling/Predicates/AnyFillPredicate.cpp \
+	Filling/Predicates/FillPredicate.cpp \
+	Filling/Predicates/IsInsideDomain_FillPredicate.cpp \
+	Filling/Predicates/IsInsideSurface_FillPredicate.cpp \
+	Filling/Predicates/IsValidInDomain_FillPredicate.cpp \
+	Filling/Predicates/IsVoidNode_FillPredicate.cpp \
+	Filling/Predicates/Ops_FillPredicate.cpp
+	
+FILLINGHEADER = \
+	Filling/Cluster.hpp \
+	Filling/ClusterInterface.hpp \
+	Filling/Mesh/CubeMesh.hpp \
+	Filling/Mesh/Mesh.hpp \
+	Filling/Filler.hpp \
+	Filling/Generators/NodeGenerator.hpp \
+	Filling/Inserter/Inserter.hpp \
+	Filling/Inserter/InserterBase.hpp \
+	Filling/Inserter/RandomInserter.hpp \
+	Filling/Inserter/SimpleInserter.hpp \
+	Filling/NodeTypes.hpp \
+	Filling/Predicates/AnyFillPredicate.hpp \
+	Filling/Predicates/FillPredicate.hpp \
+	Filling/Predicates/FillPredicateBase.hpp \
+	Filling/Predicates/FillPredicate_impl.hpp \
+	Filling/Predicates/IsInsideDomain_FillPredicate.hpp \
+	Filling/Predicates/IsInsideSurface_FillPredicate.hpp \
+	Filling/Predicates/IsValidInDomain_FillPredicate.hpp \
+	Filling/Predicates/IsVoidNode_FillPredicate.hpp \
+	Filling/Predicates/Ops_FillPredicate.hpp \
+	Filling/Predicates/Ops_FillPredicate_impl.hpp
+				  
+
+noinst_LTLIBRARIES += libMolecuilderFilling.la
+libMolecuilderFilling_la_includedir = $(includedir)/MoleCuilder/Filling/
+
+nobase_libMolecuilderFilling_la_include_HEADERS = ${FILLINGHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderFilling_la_SOURCES = ${FILLINGSOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+#libMolecuilderFilling_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+#libMolecuilderFilling_libincludedir = $(libdir)/MoleCuilder/include
+#nodist_libMolecuilderFilling_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+#pkgconfigdir = $(libdir)/pkgconfig
+#pkgconfig_DATA = $(top_builddir)/MoleCuilder.pc
Index: src/Filling/Mesh/CubeMesh.cpp
===================================================================
--- src/Filling/Mesh/CubeMesh.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Mesh/CubeMesh.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,75 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * CubeMesh.cpp
+ *
+ *  Created on: Jan 20, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <boost/lambda/lambda.hpp>
+#include <cmath>
+
+#include "CodePatterns/Log.hpp"
+#include "CubeMesh.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+/** Constructor for class CubeMesh.
+ *
+ * Here, we generate nodes homogeneously distributed over a cuboid.
+ *
+ * \a offset shifts the coordinates, e.g. if counts = 2, we would set nodes at
+ * 0 and 0.5 with offset = 0 and 0.4999... and 0.9999.. with offset = 0.999...
+ *
+ * @param counts number of points per axis
+ * @param offset offset Vector (coordinates in [0,1))
+ * @param M matrix to transform the default cuboid from (0,0,0) to (1,1,1).
+ */
+CubeMesh::CubeMesh(const Vector &counts, const Vector &offset, const RealSpaceMatrix &M)
+{
+  RealSpaceMatrix partition;
+  int n[NDIM];
+
+#ifndef NDEBUG
+  for (size_t i=0;i<NDIM;++i) {
+    ASSERT((offset[i] >= 0.) && (offset[i] < 1.),
+        "CubeMesh::CubeMesh() - offset coordinates must be in [0,1) but offset["
+        +toString(i)+"] is "+toString(offset[i])+".");
+    ASSERT(counts[i] != 0.,
+        "CubeMesh::CubeMesh() - counts["+toString(i)+"] must be != "+toString(counts[i])+".");
+  }
+#endif
+
+  partition.setZero();
+  for(int i=0;i<NDIM;i++)
+    partition.at(i,i) =  1./(double)counts[i];
+  LOG(1, "INFO: partition is " << partition << ".");
+
+
+  // go over [0,1]^3 filler grid
+  for (n[0] = 0; n[0] < counts[0]; n[0]++)
+    for (n[1] = 0; n[1] < counts[1]; n[1]++)
+      for (n[2] = 0; n[2] < counts[2]; n[2]++) {
+        const Vector CurrentPosition((double)n[0], (double)n[1], (double)n[2]);
+        nodes.push_back(M * partition * (CurrentPosition + offset));
+      }
+}
+
+/** Destructor for class CubeMesh.
+ *
+ */
+CubeMesh::~CubeMesh()
+{}
Index: src/Filling/Mesh/CubeMesh.hpp
===================================================================
--- src/Filling/Mesh/CubeMesh.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Mesh/CubeMesh.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,31 @@
+/*
+ * CubeMesh.hpp
+ *
+ *  Created on: Jan 20, 2012
+ *      Author: heber
+ */
+
+#ifndef CUBEMESH_HPP_
+#define CUBEMESH_HPP_
+
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/NodeTypes.hpp"
+#include "Mesh.hpp"
+
+class Vector;
+
+class CubeMesh : public Mesh
+{
+public:
+  CubeMesh(const Vector &counts, const Vector &offset, const RealSpaceMatrix &M);
+  virtual ~CubeMesh();
+
+};
+
+#endif /* CUBEMESH_HPP_ */
Index: src/Filling/Mesh/Mesh.cpp
===================================================================
--- src/Filling/Mesh/Mesh.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Mesh/Mesh.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,52 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Mesh.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Mesh.hpp"
+
+#include "CodePatterns/Assert.hpp"
+
+/** Constructor for class Mesh.
+ *
+ */
+Mesh::Mesh()
+{}
+
+/** Copy constructor for class Mesh.
+ *
+ * @param mesh instance to copy
+ */
+Mesh::Mesh(const Mesh &mesh) :
+    nodes(mesh.getNodes())
+{
+  ASSERT( nodes.size() == mesh.getNodes().size(),
+      "Mesh::Mesh() - copied nodes contains not the same number.");
+}
+
+/** Destructor for class Mesh.
+ *
+ */
+Mesh::~Mesh()
+{}
+
+const NodeSet & Mesh::getNodes() const
+{
+  return nodes;
+}
Index: src/Filling/Mesh/Mesh.hpp
===================================================================
--- src/Filling/Mesh/Mesh.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Mesh/Mesh.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,33 @@
+/*
+ * Mesh.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef MESH_HPP_
+#define MESH_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/NodeTypes.hpp"
+
+class Mesh
+{
+public:
+  Mesh();
+  Mesh(const Mesh &mesh);
+  virtual ~Mesh();
+
+  const NodeSet &getNodes() const;
+
+protected:
+  NodeSet nodes;
+};
+
+
+#endif /* MESH_HPP_ */
Index: src/Filling/NodeTypes.hpp
===================================================================
--- src/Filling/NodeTypes.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/NodeTypes.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,23 @@
+/*
+ * NodeTypes.hpp
+ *
+ *  Created on: 17.01.2012
+ *      Author: heber
+ */
+
+#ifndef NODETYPES_HPP_
+#define NODETYPES_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <vector>
+
+#include "LinearAlgebra/Vector.hpp"
+
+typedef Vector Node;
+typedef std::vector<Vector> NodeSet;
+
+#endif /* NODETYPES_HPP_ */
Index: src/Filling/Predicates/AnyFillPredicate.cpp
===================================================================
--- src/Filling/Predicates/AnyFillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/AnyFillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,46 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * AnyFillPredicate.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "AnyFillPredicate.hpp"
+
+/** Constructor for class AnyFillPredicate.
+ *
+ * @param _function function to use as predicate
+ */
+AnyFillPredicate::AnyFillPredicate(FillPredicator &_function) :
+  function(_function)
+{}
+
+/** Destructor for class AnyFillPredicate
+ *
+ */
+AnyFillPredicate::~AnyFillPredicate()
+{}
+
+/** Predicate implementation that simply calls upon \a AnyFillPredicate::function.
+ *
+ * @param n Node for which the predicate is to check
+ * @return true - predicate results as true, false - predicate results as false
+ */
+bool AnyFillPredicate::operator()(const Node&n) const {
+  return function(n);
+}
Index: src/Filling/Predicates/AnyFillPredicate.hpp
===================================================================
--- src/Filling/Predicates/AnyFillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/AnyFillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,41 @@
+/*
+ * AnyFillPredicate.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef ANYFILLPREDICATE_HPP_
+#define ANYFILLPREDICATE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <boost/function.hpp>
+
+#include "FillPredicateBase.hpp"
+#include "types.hpp"
+
+
+/** Allows arbitrarily bound boolean functions to represent a predicate.
+ *
+ */
+class AnyFillPredicate : public FillPredicateBase
+{
+public:
+  //!> specific type of the predicate function
+  typedef boost::function<bool(const Node&)> FillPredicator;
+
+  AnyFillPredicate(FillPredicator &_function);
+  virtual ~AnyFillPredicate();
+
+  bool operator()(const Node&n) const;
+
+private:
+  FillPredicator function;
+};
+
+
+#endif /* ANYFILLPREDICATE_HPP_ */
Index: src/Filling/Predicates/FillPredicate.cpp
===================================================================
--- src/Filling/Predicates/FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,72 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * FillPredicate.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "FillPredicate.hpp"
+
+#include "FillPredicateBase.hpp"
+#include "FillPredicate_impl.hpp"
+
+/** Constructor for class FillPredicate.
+ *
+ * @param _impl implementation to wrap
+ */
+FillPredicate::FillPredicate(FillPredicate::impl_ptr _impl) :
+    impl(_impl)
+{}
+
+/** Copy Constructor for class FillPredicate.
+ *
+ */
+FillPredicate::FillPredicate(const FillPredicate &ptr) :
+    impl(ptr.getImpl())
+{}
+
+/** Destructor for class FillPredicate.
+ *
+ */
+FillPredicate::~FillPredicate()
+{}
+
+bool FillPredicate::operator()(const Node &n) const
+{
+  return impl->operator()(n);
+}
+
+FillPredicate::impl_ptr FillPredicate::getImpl() const {
+  return impl;
+}
+
+FillPredicate AlwaysFillPredicate()
+{
+  static FillPredicate::impl_ptr impl = FillPredicate::impl_ptr(new AlwaysFillPredicate_impl());
+  return FillPredicate(impl);
+}
+
+FillPredicate NeverFillPredicate()
+{
+  static FillPredicate::impl_ptr impl = FillPredicate::impl_ptr(new NeverFillPredicate_impl());
+  return FillPredicate(impl);
+}
+
+// allows arbitrary friendship, but only if implementation is known
+FillPredicate::impl_ptr getFillPredicateImpl(const FillPredicate &f){
+  return f.getImpl();
+}
Index: src/Filling/Predicates/FillPredicate.hpp
===================================================================
--- src/Filling/Predicates/FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,51 @@
+/*
+ * FillPredicate.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef FILLPREDICATE_HPP_
+#define FILLPREDICATE_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/NodeTypes.hpp"
+
+#include <boost/shared_ptr.hpp>
+
+class FillPredicateBase;
+
+/** This class defines the interface for all derived classes.
+ *
+ * This is just a functor of a predicate function.
+ *
+ */
+class FillPredicate
+{
+public:
+  typedef boost::shared_ptr<FillPredicateBase> impl_ptr;
+  friend impl_ptr getFillPredicateImpl(const FillPredicate&);
+
+  FillPredicate(const FillPredicate &ptr);
+  FillPredicate(impl_ptr);
+  ~FillPredicate();
+  bool operator()(const Node &n) const;
+
+protected:
+  impl_ptr getImpl() const;
+
+private:
+  impl_ptr impl;
+};
+
+FillPredicate AlwaysFillPredicate();
+FillPredicate NeverFillPredicate();
+
+FillPredicate::impl_ptr getFillPredicateImpl(const FillPredicate &f);
+
+#endif /* FILLPREDICATE_HPP_ */
Index: src/Filling/Predicates/FillPredicateBase.hpp
===================================================================
--- src/Filling/Predicates/FillPredicateBase.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/FillPredicateBase.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,31 @@
+/*
+ * FillPredicateBase.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef FILLPREDICATEBASE_HPP_
+#define FILLPREDICATEBASE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Filling/NodeTypes.hpp"
+
+/** This class defines the interface for all derived classes.
+ *
+ * This is just a functor of a predicate function.
+ *
+ */
+struct FillPredicateBase
+{
+  FillPredicateBase(){};
+  virtual ~FillPredicateBase(){};
+  virtual bool operator()(const Node &n) const=0;
+};
+
+
+#endif /* FILLPREDICATEBASE_HPP_ */
Index: src/Filling/Predicates/FillPredicate_impl.hpp
===================================================================
--- src/Filling/Predicates/FillPredicate_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/FillPredicate_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,33 @@
+/*
+ * FillPredicate_impl.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef FILLPREDICATE_IMPL_HPP_
+#define FILLPREDICATE_IMPL_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicateBase.hpp"
+#include "types.hpp"
+
+class AlwaysFillPredicate_impl : public FillPredicateBase {
+public:
+  virtual bool operator()(const Node&n) const{
+    return true;
+  }
+};
+
+class NeverFillPredicate_impl : public FillPredicateBase {
+public:
+  virtual bool operator()(const Node&n) const{
+    return false;
+  }
+};
+
+#endif /* FILLPREDICATE_IMPL_HPP_ */
Index: src/Filling/Predicates/IsInsideDomain_FillPredicate.cpp
===================================================================
--- src/Filling/Predicates/IsInsideDomain_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsInsideDomain_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,36 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsInsideDomain_FillPredicate.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <boost/bind.hpp>
+
+#include "IsInsideDomain_FillPredicate.hpp"
+
+#include "AnyFillPredicate.hpp"
+#include "Box.hpp"
+#include "FillPredicate.hpp"
+
+FillPredicate IsInsideDomain_FillPredicate(const Box &domain)
+{
+  AnyFillPredicate::FillPredicator function = boost::bind(&Box::isInside, &domain, _1);
+  FillPredicate::impl_ptr impl(new AnyFillPredicate(function));
+  return FillPredicate(impl);
+}
Index: src/Filling/Predicates/IsInsideDomain_FillPredicate.hpp
===================================================================
--- src/Filling/Predicates/IsInsideDomain_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsInsideDomain_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,22 @@
+/*
+ * IsInsideDomain_FillPredicate.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef ISINSIDEDOMAIN_FILLPREDICATE_HPP_
+#define ISINSIDEDOMAIN_FILLPREDICATE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicate.hpp"
+
+class Box;
+
+FillPredicate IsInsideDomain_FillPredicate(const Box &domain);
+
+#endif /* ISINSIDEDOMAIN_FILLPREDICATE_HPP_ */
Index: src/Filling/Predicates/IsInsideSurface_FillPredicate.cpp
===================================================================
--- src/Filling/Predicates/IsInsideSurface_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsInsideSurface_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,36 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsInsideSurface_FillPredicate.cpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <boost/bind.hpp>
+
+#include "IsInsideSurface_FillPredicate.hpp"
+
+#include "AnyFillPredicate.hpp"
+#include "FillPredicate.hpp"
+#include "Tesselation/tesselation.hpp"
+
+FillPredicate IsInsideSurface_FillPredicate(const Tesselation &_tess, const LinkedCell_deprecated &_LC)
+{
+  AnyFillPredicate::FillPredicator function = boost::bind(&Tesselation::IsInnerPoint, &_tess, _1, &_LC);
+  FillPredicate::impl_ptr impl(new AnyFillPredicate(function));
+  return FillPredicate(impl);
+}
Index: src/Filling/Predicates/IsInsideSurface_FillPredicate.hpp
===================================================================
--- src/Filling/Predicates/IsInsideSurface_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsInsideSurface_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,25 @@
+/*
+ * IsInsideSurface_FillPredicate.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef ISINSIDESURFACE_FILLPREDICATE_HPP_
+#define ISINSIDESURFACE_FILLPREDICATE_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicate.hpp"
+
+class LinkedCell_deprecated;
+class Tesselation;
+
+
+FillPredicate IsInsideSurface_FillPredicate(const Tesselation &_tess, const LinkedCell_deprecated &_LC);
+
+#endif /* ISINSIDESURFACE_FILLPREDICATE_HPP_ */
Index: src/Filling/Predicates/IsValidInDomain_FillPredicate.cpp
===================================================================
--- src/Filling/Predicates/IsValidInDomain_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsValidInDomain_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,37 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsValidInDomain_FillPredicate.cpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <boost/bind.hpp>
+
+#include "IsValidInDomain_FillPredicate.hpp"
+
+#include "AnyFillPredicate.hpp"
+#include "Box.hpp"
+#include "FillPredicate.hpp"
+
+
+FillPredicate IsValidInDomain_FillPredicate(const Box &domain)
+{
+  AnyFillPredicate::FillPredicator function = boost::bind(&Box::isValid, &domain, _1);
+  FillPredicate::impl_ptr impl(new AnyFillPredicate(function));
+  return FillPredicate(impl);
+}
Index: src/Filling/Predicates/IsValidInDomain_FillPredicate.hpp
===================================================================
--- src/Filling/Predicates/IsValidInDomain_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsValidInDomain_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,22 @@
+/*
+ * IsValidInDomain_FillPredicate.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef ISVALIDINDOMAIN_FILLPREDICATE_HPP_
+#define ISVALIDINDOMAIN_FILLPREDICATE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicate.hpp"
+
+class Box;
+
+FillPredicate IsValidInDomain_FillPredicate(const Box &domain);
+
+#endif /* ISVALIDINDOMAIN_FILLPREDICATE_HPP_ */
Index: src/Filling/Predicates/IsVoidNode_FillPredicate.cpp
===================================================================
--- src/Filling/Predicates/IsVoidNode_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsVoidNode_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,72 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsVoidNode_FillPredicate.cpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <boost/bind.hpp>
+
+#include "IsVoidNode_FillPredicate.hpp"
+
+#include "CodePatterns/Log.hpp"
+
+#include "Atom/TesselPoint.hpp"
+#include "LinkedCell/LinkedCell_View.hpp"
+#include "Shapes/ShapeOps.hpp"
+#include "Tesselation/tesselation.hpp"
+#include "World.hpp"
+
+#include "AnyFillPredicate.hpp"
+#include "FillPredicate.hpp"
+
+/** Checks whether a given node \a n in the domain is empty with respect to the
+ * given \a shape.
+ *
+ * @param LC View of a linked cell structure for finding neighbors quickly
+ * @param shape shape as a sort of placeholder
+ * @param n point where to center the placeholder
+ * @return true - placeholder at node contains no points,
+ *         false - there is at least one point contained
+ */
+bool IsVoidNode(const LinkedCell::LinkedCell_View &LC, const Shape &shape, const Node &n)
+{
+  LOG(3, "DEBUG: Node is " << n << ".");
+  LOG(3, "DEBUG: Original shape is at " << shape.getCenter() << " with radius of "
+      << shape.getRadius() << ".");
+  const Shape shapeAtn = translate(shape, n);
+  LOG(3, "DEBUG: Translated shape is at " << shapeAtn.getCenter() << ".");
+  LinkedCell::LinkedList neighborlist = LC.getAllNeighbors(
+      shapeAtn.getRadius(), shapeAtn.getCenter());
+  LOG(3, "DEBUG: we have " << neighborlist.size() << " possible neighbors.");
+  LinkedCell::LinkedList::const_iterator neighboriter =
+      std::find_if(neighborlist.begin(), neighborlist.end(),
+          boost::bind(&Shape::isInside, shapeAtn,
+              boost::bind(&TesselPoint::getPosition, _1) ));
+  return neighboriter == neighborlist.end();
+}
+
+FillPredicate IsVoidNode_FillPredicate(const Shape &_shape)
+{
+  // copy _shape !
+  const LinkedCell::LinkedCell_View LC = World::getInstance().getLinkedCell(_shape.getRadius());
+  AnyFillPredicate::FillPredicator function = boost::bind(&IsVoidNode, LC, _shape, _1);
+  LOG(2, "DEBUG: Create IsVoidNode_FillPredicate from shape at "
+      << _shape.getCenter() << " and radius " << _shape.getRadius() << ".");
+  FillPredicate::impl_ptr impl(new AnyFillPredicate(function));
+  return FillPredicate(impl);
+}
Index: src/Filling/Predicates/IsVoidNode_FillPredicate.hpp
===================================================================
--- src/Filling/Predicates/IsVoidNode_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/IsVoidNode_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,25 @@
+/*
+ * IsVoidNode_FillPredicate.hpp
+ *
+ *  Created on: Jan 16, 2012
+ *      Author: heber
+ */
+
+#ifndef ISVOIDNODE_FILLPREDICATE_HPP_
+#define ISVOIDNODE_FILLPREDICATE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicate.hpp"
+
+namespace LinkedCell {
+  class LinkedCell_View;
+}
+class Shape;
+
+FillPredicate IsVoidNode_FillPredicate(const Shape &_shape);
+
+#endif /* ISVOIDNODE_FILLPREDICATE_HPP_ */
Index: src/Filling/Predicates/Ops_FillPredicate.cpp
===================================================================
--- src/Filling/Predicates/Ops_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/Ops_FillPredicate.cpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,44 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * Ops_FillPredicate.cpp
+ *
+ *  Created on: 17.01.2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Ops_FillPredicate.hpp"
+#include "Ops_FillPredicate_impl.hpp"
+
+FillPredicate operator&&(const FillPredicate &a, const FillPredicate &b)
+{
+  FillPredicate::impl_ptr impl_ptr = FillPredicate::impl_ptr(
+      new And_FillPredicate(getFillPredicateImpl(a),getFillPredicateImpl(b)));
+	return FillPredicate(impl_ptr);
+}
+
+FillPredicate operator||(const FillPredicate &a, const FillPredicate &b)
+{
+  FillPredicate::impl_ptr impl_ptr = FillPredicate::impl_ptr(
+      new Or_FillPredicate(getFillPredicateImpl(a),getFillPredicateImpl(b)));
+  return FillPredicate(impl_ptr);
+}
+
+FillPredicate operator!(const FillPredicate &a)
+{
+  FillPredicate::impl_ptr impl_ptr = FillPredicate::impl_ptr(
+      new Not_FillPredicate(getFillPredicateImpl(a)));
+  return FillPredicate(impl_ptr);
+}
Index: src/Filling/Predicates/Ops_FillPredicate.hpp
===================================================================
--- src/Filling/Predicates/Ops_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
+++ src/Filling/Predicates/Ops_FillPredicate.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -0,0 +1,24 @@
+/*
+ * Ops_FillPredicate.hpp
+ *
+ *  Created on: 17.01.2012
+ *      Author: heber
+ */
+
+#ifndef OPS_FILLPREDICATE_HPP_
+#define OPS_FILLPREDICATE_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FillPredicate.hpp"
+
+
+FillPredicate operator&&(const FillPredicate &a, const FillPredicate &b);
+FillPredicate operator||(const FillPredicate &a, const FillPredicate &b);
+FillPredicate operator!(const FillPredicate &a);
+
+
+#endif /* OPS_FILLPREDICATE_HPP_ */
